'From Squeak3.3alpha of 30 January 2002 [latest update: #4798] on 30 March 2002 at 8:13:54 pm'!
AlignmentMorph subclass: #FreeCell
	instanceVariableNames: 'board cardsRemainingDisplay elapsedTimeDisplay gameNumberDisplay lastGameLost state autoMoveRecursionCount myFillStyle '
	classVariableNames: 'Statistics '
	module: #(Squeak Morphic Demo Games)!

!FreeCell methodsFor: 'initialization' stamp: 'ar 11/9/2000 21:17'!
initialize

	super initialize.
	Statistics newSession.
	autoMoveRecursionCount _ 0.
	self listDirection: #topToBottom.
	self wrapCentering: #center; cellPositioning: #topCenter.
	self vResizing: #shrinkWrap.
	self hResizing: #shrinkWrap.
	self
		color: self colorNearTop;
		borderWidth: 2;
		addMorph: self makeControls;
		addMorph: self board;
		newGame.

! !

!FreeCell methodsFor: 'initialization' stamp: 'djp 10/16/1999 17:17'!
makeCardsRemainingDisplay

	cardsRemainingDisplay _ LedMorph new
		digits: 2;
		extent: (2*10@15).
	^self wrapPanel: cardsRemainingDisplay label: 'Cards Left: '! !

!FreeCell methodsFor: 'initialization' stamp: 'ar 11/9/2000 21:17'!
makeControlBar

	^AlignmentMorph newRow
		color: self colorNearBottom;
		borderColor: #inset;
		borderWidth: 2;
		layoutInset: 0;
		hResizing: #spaceFill; vResizing: #shrinkWrap; wrapCentering: #center; cellPositioning: #leftCenter;
		yourself.! !

!FreeCell methodsFor: 'initialization' stamp: 'djp 10/24/1999 14:38'!
makeControls

	^self makeControlBar
		addMorph: AlignmentMorph newVariableTransparentSpacer;
		addMorph: self makeHelpButton;
		addMorph: self makeQuitButton;
		addMorph: self makeStatisticsButton;
		addMorph: self makeGameNumberDisplay;
		addMorph: self makePickGameButton;
		addMorph: self makeSameGameButton;
		addMorph: self makeNewGameButton;
		addMorph: self makeElapsedTimeDisplay;
		addMorph: self makeCardsRemainingDisplay;
		yourself.! !

!FreeCell methodsFor: 'initialization' stamp: 'djp 10/23/1999 21:27'!
makeElapsedTimeDisplay

	elapsedTimeDisplay _ LedTimerMorph new
		digits: 3;
		extent: (3*10@15).
	^self wrapPanel: elapsedTimeDisplay label: 'Elapsed Time: '! !

!FreeCell methodsFor: 'initialization' stamp: 'djp 10/23/1999 22:45'!
makeGameNumberDisplay

	gameNumberDisplay _ LedMorph new
		digits: 5;
		extent: (5*10@15).
	^self wrapPanel: gameNumberDisplay label: 'Game #: '! !

!FreeCell methodsFor: 'initialization' stamp: 'di 10/19/1999 01:12'!
makeHelpButton

	^self
		buildButton: SimpleButtonMorph new
		target: self
		label: 'Help'
		selector: #help! !

!FreeCell methodsFor: 'initialization' stamp: 'djp 10/16/1999 15:05'!
makeNewGameButton

	^self
		buildButton: SimpleButtonMorph new
		target: self
		label: 'New game'
		selector: #newGame! !

!FreeCell methodsFor: 'initialization' stamp: 'djp 10/23/1999 22:46'!
makePickGameButton

	^self
		buildButton: SimpleButtonMorph new
		target: self
		label: 'Pick game'
		selector: #pickGame! !

!FreeCell methodsFor: 'initialization' stamp: 'djp 10/23/1999 21:18'!
makeQuitButton

	^self
		buildButton: SimpleButtonMorph new
		target: self
		label: 'Quit'
		selector: #quit
! !

!FreeCell methodsFor: 'initialization' stamp: 'djp 10/17/1999 17:44'!
makeSameGameButton

	^self
		buildButton: SimpleButtonMorph new
		target: self
		label: 'Same game'
		selector: #sameGame! !

!FreeCell methodsFor: 'initialization' stamp: 'djp 10/24/1999 14:38'!
makeStatisticsButton

	^self
		buildButton: SimpleButtonMorph new
		target: self
		label: 'Statistics'
		selector: #statistics! !

!FreeCell methodsFor: 'initialization' stamp: 'djp 10/31/1999 18:48'!
openInWindowLabeled: aString inWorld: aWorld

	^(super openInWindowLabeled: aString inWorld: aWorld)
		model: self;
		yourself! !


!FreeCell methodsFor: 'accessing' stamp: 'djp 10/31/1999 19:28'!
board

	board ifNil: 
		[board _ FreeCellBoard new
			target: self;
			actionSelector: #boardAction:].
	^board! !

!FreeCell methodsFor: 'accessing' stamp: 'djp 10/24/1999 21:36'!
currentGame

	^self board cardDeck seed! !

!FreeCell methodsFor: 'accessing' stamp: 'djp 10/25/1999 21:56'!
helpText

	^'The objective of FreeCell is to move all of the cards to the four "home cells" in the upper right corner.  Each home cell will hold one suit and must be filled sequentially starting with the Ace.

There are four "free cells" in the upper left corner that can each hold one card.  Cards can be moved from the bottom of a stack to a free cell or to another stack.  

When moving a card to another stack, it must have a value that is one less than the exposed card and of a different color.'! !


!FreeCell methodsFor: 'actions' stamp: 'djp 10/31/1999 21:17'!
autoMovingHome

	elapsedTimeDisplay pause.
	autoMoveRecursionCount _ autoMoveRecursionCount + 1.! !

!FreeCell methodsFor: 'actions' stamp: 'djp 10/31/1999 21:35'!
boardAction: actionSymbol

	actionSymbol = #cardMovedHome 	ifTrue: [^self cardMovedHome].
	actionSymbol = #autoMovingHome	ifTrue: [^self autoMovingHome].! !

!FreeCell methodsFor: 'actions' stamp: 'di 3/5/2000 15:30'!
cardMovedHome

	cardsRemainingDisplay value: (cardsRemainingDisplay value - 1).
	autoMoveRecursionCount _ autoMoveRecursionCount - 1 max: 0.
	cardsRemainingDisplay value = 0 
		ifTrue: [self gameWon]
		ifFalse: [autoMoveRecursionCount = 0 ifTrue: [elapsedTimeDisplay continue]].! !

!FreeCell methodsFor: 'actions' stamp: 'di 3/5/2000 16:20'!
gameLost

	state _ #lost.
	elapsedTimeDisplay stop.
	cardsRemainingDisplay highlighted: true; flash: true.
	Statistics gameLost: self currentGame! !

!FreeCell methodsFor: 'actions' stamp: 'di 3/5/2000 16:20'!
gameWon

	state _ #won.
	elapsedTimeDisplay stop; highlighted: true; flash: true.
	Statistics gameWon: self currentGame! !

!FreeCell methodsFor: 'actions' stamp: 'di 10/19/1999 01:12'!
help
	| window helpMorph |

	window _ SystemWindow labelled: 'FreeCell Help'.
	window model: self.
	helpMorph _ (PluggableTextMorph new editString: self helpText)
				 lock.
	window addMorph: helpMorph frame: (0@0 extent: 1@1).
	window openInWorld.
! !

!FreeCell methodsFor: 'actions' stamp: 'di 12/12/2000 13:08'!
inAutoMove
	"Return true if an automove sequence is in progress"

	^ autoMoveRecursionCount > 0! !

!FreeCell methodsFor: 'actions' stamp: 'th 12/15/1999 15:20'!
modelSleep
	"When fixing #contains: calls beware of reinventing #includes:"
	(#(newGame sameGame pickGame won lost ) includes: state)
		ifTrue: [elapsedTimeDisplay pause]! !

!FreeCell methodsFor: 'actions' stamp: 'th 12/15/1999 15:22'!
modelWakeUp
	"Maybe less performant but more readable"
	(#(won lost) includes: state)
		ifFalse: [elapsedTimeDisplay resume]! !

!FreeCell methodsFor: 'actions' stamp: 'di 1/16/2000 10:35'!
newGame
	Collection initialize.
	self newGameNumber: nil.
	state _ #newGame! !

!FreeCell methodsFor: 'actions' stamp: 'di 3/5/2000 16:21'!
newGameNumber: aSeedOrNil 
	cardsRemainingDisplay value ~~ 0 ifTrue: [self gameLost].
	cardsRemainingDisplay flash: false; highlighted: false; value: 52.
	elapsedTimeDisplay flash: false; highlighted: false.
	"board handles nil case"
	self board pickGame: aSeedOrNil.
	elapsedTimeDisplay reset; start.
	gameNumberDisplay value: self currentGame! !

!FreeCell methodsFor: 'actions' stamp: 'th 12/15/1999 15:05'!
pickGame
	| seed |
	seed _ self promptForSeed.
	seed isNil ifTrue: [^ self].
	self newGameNumber: seed.
	state _ #pickGame! !

!FreeCell methodsFor: 'actions' stamp: 'tk 3/30/2001 13:25'!
promptForSeed
	| ss ii hh |
	
	[hh _ board hardness ifNil: [0].
	ss _ FillInTheBlank request: 'Pick a game number between 1 and 32000.
or
set the hardness of the next game by typing ''H 30''.
Above 100 is very hard.  Zero is standard game.
Current hardness is: ', hh printString.
		"Let the user cancel."
		ss isEmpty ifTrue: [^ nil].
		ss _ ss withoutQuoting.
		ss first asLowercase == $h ifTrue: ["Set the hardness"
			[ii _ ss numericSuffix] on: Error do: [ii _ 0].
			board hardness: ii.
			^ nil].
		[ii _ ss asNumber asInteger] on: Error do: [ii _ 0].
		ii between: 1 and: 32000] whileFalse.
	^ ii! !

!FreeCell methodsFor: 'actions' stamp: 'di 3/5/2000 15:35'!
quit
	cardsRemainingDisplay value ~~ 0 ifTrue: [self gameLost].

	self owner == self world
		ifTrue: [self delete]
		ifFalse: [self owner delete].
	Statistics close! !

!FreeCell methodsFor: 'actions' stamp: 'th 12/15/1999 15:03'!
sameGame
	self newGameNumber: self currentGame.
	state _ #sameGame.

! !

!FreeCell methodsFor: 'actions' stamp: 'djp 10/24/1999 15:07'!
statistics

	Statistics display! !


!FreeCell methodsFor: 'private' stamp: 'ar 11/9/2000 21:16'!
buildButton: aButton target: aTarget label: aLabel selector: aSelector
	"wrap a button or switch in an alignmentMorph to provide some space around the button"

	| a |
	aButton 
		target: aTarget;
		label: aLabel;
		actionSelector: aSelector;
		borderColor: #raised;
		borderWidth: 2;
		color: Color gray.
	a _ AlignmentMorph newColumn
		wrapCentering: #center; cellPositioning: #topCenter;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		color: Color transparent;
		layoutInset: 1.
	a addMorph: aButton.
	^ a

! !

!FreeCell methodsFor: 'private' stamp: 'ar 11/9/2000 21:17'!
wrapPanel: anLedPanel label: aLabel
	"wrap an LED panel in an alignmentMorph with a label to its left"

	| a |
	a _ AlignmentMorph newRow
		wrapCentering: #center; cellPositioning: #leftCenter;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		borderWidth: 0;
		layoutInset: 5;
		color: Color transparent.
	a addMorph: anLedPanel.
	a addMorph: (StringMorph contents: aLabel). 
	^ a
! !


!FreeCell methodsFor: 'visual properties' stamp: 'RAA 3/3/2000 23:28'!
colorNearBottom

	^Color r: 0.0 g: 0.455 b: 0.18! !

!FreeCell methodsFor: 'visual properties' stamp: 'RAA 3/4/2000 10:26'!
colorNearTop

	^ (Color r: 0.304 g: 0.833 b: 0.075)! !

!FreeCell methodsFor: 'visual properties' stamp: 'RAA 3/3/2000 23:29'!
defaultBackgroundColor

	^Color r: 0.365 g: 1.0 b: 0.09! !


!FreeCell methodsFor: 'as yet unclassified' stamp: 'RAA 3/4/2000 17:01'!
fillStyle

	myFillStyle ifNil: [
		myFillStyle _ GradientFillStyle ramp: {
			0.0 -> self colorNearTop. 
			1.0 -> self colorNearBottom
		}.
	].
	^myFillStyle
		origin: self position;
		direction: (self width // 2)@self height
! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

FreeCell class
	instanceVariableNames: ''!

!FreeCell class methodsFor: 'class initialization' stamp: 'djp 10/24/1999 14:50'!
initialize

	Statistics _ FreeCellStatistics new.! !


!FreeCell class methodsFor: 'parts bin' stamp: 'sw 8/2/2001 12:50'!
descriptionForPartsBin
	^ self partName:	'FreeCell'
		categories:		#('Games')
		documentation:	'A unique solitaire card game'! !


FreeCell initialize!
